c file cbcReaderHyd.for

! Compiled and linked with Gnu Fortran:
! Prior to compiling, linking or running:
!   set path=%path%;C:\MinGW\bin\
! To compile:
!   Switches: -c: Compile without linking; -o [specify executable_filename]; -ffree-line-length-none (free format source code, no line length limit), -Wall (Warnings all)
!   gfortran -c -Wall -Wextra -fcheck=bounds -Fbacktrace -ffree-line-length-none cbcReaderHyd.for
!   gfortran -static -o cbcReaderHyd cbcReaderHyd.o

      program cbcReaderHyd

      parameter (nr=180, nc=335)       !rows, columns
!      parameter (nper=817)   !stress periods
      parameter (nstr=5705)  !stream reaches
      integer nzones, istep
      !180 rows and 335 cols
      integer ibound(nc,nr)
!      integer isrow(300),iscol(300)


      real*8  :: well(nc,nr),rech(nc,nr),et(nc,nr),
     +           storage(nc,nr),ch(nc,nr),
     +           RtFace(nc,nr),FtFace(nc,nr)
!      real*8  :: drain(nc,nr),stream(nc,nr),

      real*8 ::  sumw(10),sumr(10),sumet(10),sumd(10),
     +           sumsto(10),sumstr(10),sumch(10),sumrtface(10),
     +           sumftface(10),SUMFIS(10),SUMFTA(10),SUMFOS(10),
     +           sumovrnf(10),sumprecip(10),sumstret(10)

      real*8 ::  FTA(nstr),FIS(nstr),FOS(nstr),OVRNF(nstr),
     +           PRECIP(nstr),SET(nstr)

      real*8 ::  daysmo,daystp,conv

ccc      real*8 ::  totalet(180,335),totalStrm(180,335),
ccc     +           totalovrnf(180,335),totalstrmet(180,335)
  
      character text*16, record*160
      character*50 fmtstring
      
      INTEGER :: SLAY(nstr),SROW(nstr),SCOL(nstr),SEG(nstr),REACH(nstr)

!       added declarations (spp KDA/DWR)

      character*256 FILE
!      character*256 LINE

      character*80 casename,maskfile
      character*6 chopt_BGT           !option (2nd line of input file): BUDGET or NO BUDGET
      integer iopt_BGT                !indicator based on chopt_BGT: set to 1 to write budget.
      character*80 wbdfile,rbdfile,ebdfile,cbbfile,sbdfile,postfile
!      character*10 postfolder
      integer im1,firstyr,lastyr
      
! hydrograph declarations
      character*80 hdsfile
      real*8   :: heads(nc,nr)
      real*8   :: PERTIM,TOTIM

      parameter (mxhyd=20)  !max. no. hydrographs

      character*80 hydfile
      character*2 arrval, arr(mxhyd)
      integer nhyd, hydlay(mxhyd),hydrow(mxhyd),hydcol(mxhyd) !cell (layer,row,col) for arr='HD'
      integer hydseg(mxhyd),hydrch(mxhyd)                     !stream (segment,reach) for arr='SI' or 'SO'
      integer i,ios
      character*20 hydlbl(mxhyd)                              !hydrograph label
      real*8   :: hydval(mxhyd)

      !data daysmo/31,28,31,30,31,30,31,31,30,31,30,31/

      daysmo=30.43750     !set days/mo to 365.25 / 12
      daystp = daysmo/3.  !days/time step = 365.25/36
c
      conv=daystp/43560.D0  !use to convert cu.ft/day to acre-feet

c      nr=180       !rows
c      nc=335       !cols
c      nper=817     !stress periods
c      nstr=5705    !stream reaches
!
      if (IARGC().ne.1) then
        write(*,*) 'Usage: cbcReaderHyd <parameter file>'
        STOP
      endif
      call GETARG(1,FILE)
      write(*,*) 'Open '//trim(FILE)
      OPEN(1,FILE=FILE,STATUS='OLD',IOSTAT=IOS)
      if (IOS.ne.0) then
        write(*,*) 'Error opening '//trim(FILE)
        STOP
      endif

      read(1,'(a)') casename
      write(*,*) 'Scenario casename: '//trim(casename)
      read(1,'(a)') chopt_BGT
      iopt_BGT=0
      if(Index(chopt_BGT,'BUDGET').gt.0) iopt_BGT=1
        
      hdsfile = trim(casename)//'.hds'
      sbdfile = trim(casename)//'.sbd'

c     ASCII Stream file
      open(16,file=trim(sbdfile)) !STREAM BUDGET COMPONENTS - ASCII FILE

      if(iopt_BGT.eq.1) then
        wbdfile = trim(casename)//'.wbd'
        rbdfile = trim(casename)//'.rbd'
        ebdfile = trim(casename)//'.ebd'
        cbbfile = trim(casename)//'.cbb'
c         write(*,*) 'cbc well file: '//trim(wbdfile)
c        1         2         3         4         5         6         7 2
        open(11,file=trim(wbdfile),
     |      form='unformatted',access='sequential') !BINARY CELL BY CELL WELL BUDGET FILE
        open(12,file=trim(rbdfile),
     |      form='unformatted',access='sequential') !BINARY CELL BY CELL RECHARGE BUDGET FILE
        open(13,file=trim(ebdfile),
     |      form='unformatted',access='sequential') !BINARY CELL BY CELL ET BUDGET FILE
        open(15,file=trim(cbbfile),
     |      form='unformatted',access='sequential') !BINARY CELL BY CELL BUDGET FILE CONTAINING CELL BY CELL GW FLOW TERMS
      endif

      write(*,*) 'Mask filename: '        !RSMask.txt with nzones = 1 for the Rattlesnake C mask (includes tribs within RS basin)
      read(1,'(a)') maskfile
      write(*,*) 'Mask filename = '//trim(maskfile)
      write(*,*) 'First and last calendar year: '
      read(1,*) firstyr,lastyr
      write(*,*) 'read output from ',firstyr,' to ',lastyr

!       hydrographs:
      arr=' '
      hydlay=0
      hydrow=0
      hydcol=0
      hydseg=0
      hydrch=0
      hydlbl=' '

      read(1,*) nhyd
      if (ios.ne.0) nhyd=0
      if (nhyd.gt.0) then
        open(17,file=trim(hdsfile),form='unformatted',
     |          access='sequential')         !computed heads unformatted sequential file
        hydfile = trim(casename)//'.hdo'     !use .hdo for hydrograph output file extension
        open(30,file=trim(hydfile))          !hydrograph output - text file

        do i=1,nhyd
          read(1,*) arr(i)
          backspace(1)
          if (arr(i).eq.'HD') then
c        1         2         3         4         5         6         7 2
            read(1,*) arrval,hydlay(i),hydrow(i),hydcol(i),hydlbl(i)
            write(*,*) 'hydrograph ',i,arr(i),
     |                  hydlay(i),hydrow(i),hydcol(i),hydlbl(i)
          elseif (arr(i).eq.'SI'.or.arr(i).eq.'SO') then
            read(1,*) arrval,hydlay(i),hydseg(i),hydrch(i),hydlbl(i)
            write(*,*) 'hydrograph ',i,arr(i),
     |                  hydlay(i),hydseg(i),hydrch(i),hydlbl(i)
          else
            write(*,*) 'undefined type for hydrograph ',i
            STOP
          endif
        enddo
        write(30,'(a18,2a24,20a24)') ' year mo kper kstp',
     |         'PERTIM','TOTIM',(arr(i)//'_'//hydlbl(i),i=1,nhyd)
      endif
      close(1)

c-----For the Rattlesnake C Mask----------------------------------
      nzones=1
      open(22,file=trim(maskfile))
      fmtstring ='(335i1)' 
      do i=1,nr
          read(22,fmtstring) (ibound(j,i),j=1,nc)        
      end do
      close(22)
      postfile = trim(casename)//'.bgt'
c        1         2         3         4         5         6         7 2
c-----------------------------------------------------------------------

      if(iopt_BGT.eq.1) then
        write(*,*) 'write flow budget summary to '//trim(postfile)
        open(31,file=trim(postfile),status='replace')

        do i=1,nzones
          write(30+i,'(A)')trim( ' year       pumping      recharge'//
     +    ' evapotranspir       storage     RightFace     FrontFace'//
     +    '  FlowintoStrm   FlowToAquif  FlowOutStrms'//
     +    '        Runoff        Precip         StrET')
        end do
      endif      !(iopt_BGT.eq.1)

      t0=0.

C     Read Transient State
      
      totalet=0.0
      totalstrm=0.0
      totalovrnf=0.0
      totalstrmet=0.0
      
      do ny=firstyr,lastyr        !historical period: 1939,2007
        sumw=0.
        sumr=0.
        sumet=0.
        sumd=0.
        sumch=0.
        sumsto=0.
        sumch=0.
        sumstr=0.
        SUMFIS=0.
        SUMFTA=0.
        SUMFOS=0.
        sumrtface=0.
        sumftface=0.
        SUMOVRNF=0.
        SUMPRECIP=0.
        SUMSTRET=0.

        if (ny.eq.1939) then
            im1=12
        else
            im1=1
        endif

        do im=im1,12
          do istep=1,3  !3 time steps/stress period; flows and heads are written for each time step
            if (iopt_BGT.eq.1) then
c---------Well Budget------------------------------------------          
              read(11) kstpw,kper,text,ncol,nrow,nlay
              write(*,'(2i5,a16,6i5)') kstpw,kper,text,ncol,nrow,nlay,
     +                             istep,im,ny
              read(11) well
c---------Recharge Budget---------------------------------------          
              read(12) kstpr,kper,text,ncol,nrow,nlay
              write(*,'(2i5,a16,6i5)') kstpr,kper,text,ncol,nrow,nlay,
     +                             istep,im,ny
              read(12) rech
c---------ET budget---------------------------------------------          
              read(13) kstpe,kper,text,ncol,nrow,nlay
              write(*,'(2i5,a16,6i5)') kstpe,kper,text,ncol,nrow,nlay,
     +                             istep,im,ny
              read(13) et
C PK-----------------NO DRAINS IN THIS MODEL-----------------------------------
C PK          read(14) nv,kstpd,kper,text,ncol,nrow,nlay,nv
C PK c          write(*,'(2i5,a16,3i5)') kstpd,kper,text,ncol,nrow,nlay
C PK          read(14) nv,drain,nv
CPK -----------------NO DRAINS IN THIS MODEL------------------------------------

c----------Storage---------------------------------------------------------------
              read(15) kstpsto,kper,text,ncol,nrow,nlay
              write(*,'(2i5,a16,6i5)') kstpsto,kper,text,ncol,nrow,nlay,         
     +                             istep,im,ny
              read(15) storage
c---------Constant Head----------------------------------------------------------          
              read(15) kstpch,kper,text,ncol,nrow,nlay
              write(*,'(2i5,a16,6i5)') kstpch,kper,text,ncol,nrow,nlay,
     +                             istep,im,ny
              read(15) ch
C---------Flow Right Face, -------------------------------------------------------
              read(15) kstp,kper,text,ncol,nrow,nlay
              write(*,'(2i5,a16,6i5)') kstp,kper,text,ncol,nrow,nlay,           
     +                             istep,im,ny
              read(15) RtFace
C---------Flow Front Face------------------------------------------------------------
              read(15) kstp,kper,text,ncol,nrow,nlay
              write(*,'(2i5,a16,6i5)') kstp,kper,text,ncol,nrow,nlay,
     +                             istep,im,ny
              read(15) FtFace

            endif    ! (iopt_BGT.eq.1)

c----------Stream budget---ASCII format------------------------------------------
            do idummy=1,8
              read(16,'(A128)') record
              if(ny.eq.1939) write(*,'(1x,A128)') record
            end do

c        1         2         3         4         5         6         7 2
c-----------------------------------------------------------------------
            do I=1,nstr          
              read(16,*) SLAY(I),SROW(I),SCOL(I),SEG(I),REACH(I),
     |            FIS(I),FTA(I),FOS(I),OVRNF(I),PRECIP(I),SET(I),
     |            V1,V2,V3,V4,V5              
            end do                      
!160        format(I4,2I5,2I6,E16.6,E14.6,E15.6,3E14.6,E13.5,4E14.6)
C
c PK          read(16) nv,kstpstr,kper,text,ncol,nrow,nlay,nv          
c          write(*,'(2i5,a16,3i5)') kstpstr,kper,text,ncol,nrow,nlay
C PK          read(16) nv,stream,nv
c          pause

            if (nhyd.gt.0) then

c---------Computed Heads----------------------------------------------------------          
              read(17) KSTP,KPER,PERTIM,TOTIM,TEXT,NCOL,NROW,NLAY
              read(17) heads

c---------Retrieve and write hydrographs----------------------------------------------------------          
              do i=1,nhyd
                if(arr(i).eq.'HD') then
                  hydval(i) = heads(hydcol(i),hydrow(i))      !computed head (ft)
                elseif(arr(i).eq.'SI') then
                  hydval(i) = FIS(hydseg(i))/86400.           !convert inflow from cu.ft/day to cfs
                elseif(arr(i).eq.'SO') then
                  hydval(i) = FOS(hydseg(i))/86400.           !convert outflow from cu.ft/day to cfs
                endif
              enddo
              write(30,'(i5,i3,2i5,2g24.8,20g24.8)') ny,im,
     |            kper,kstp,pertim,totim,(hydval(i),i=1,nhyd)
            endif  ! nhyd > 0
C
C         Calculate budget sums
c          is=1
        if (iopt_BGT.eq.1) then
          do i =1,nr
            do j=1,nc
              is = ibound(j,i)
              if (is.gt.0 ) then

                sumw(is)=sumw(is)+well(j,i)*conv                
                sumr(is)=sumr(is)+rech(j,i)*conv
                sumet(is)=sumet(is)+et(j,i)*conv 
                sumsto(is)=sumsto(is)+storage(j,i)*conv
                sumch(is)=sumch(is)+ch(j,i)*conv
                         
                if(j .gt. 1) then
                  sumrtface(is)=sumrtface(is)+
     +              (rtface(j,i)-rtface(j-1,i))*conv
                else
                  sumrtface(is)=sumrtface(is) + (rtface(j,i))*conv
                endif

                if(i .gt. 1) then
                  sumftface(is)=sumftface(is)+
     +              (ftface(j,i)-ftface(j,i-1))*conv
                else
                  sumftface(is)=sumftface(is) + (ftface(j,i))*conv
                endif                    
                    
              endif
            end do
          end do
          do ns=1,nstr
              j=scol(ns)
              i=srow(ns)
              is=ibound(j,i)             
              if (is .gt.0 ) then
                SUMFIS(IS) =SUMFIS(IS)+FIS(NS)*conv
                SUMFTA(IS) =SUMFTA(IS)+FTA(NS)*conv 
                SUMFOS(IS) =SUMFOS(IS)+FOS(NS)*conv

                SUMovrnf(is)=SUMovrnf(is)+ovrnf(NS)*conv
                SUMPRECIP(is)=SUMPRECIP(is)+PRECIP(NS)*conv
                SUMSTRET(is)=SUMSTRET(is)+SET(NS)*conv

              ENDIF
          end do
        endif         !(iopt_BGT.eq.1)

          end do     !istep=1,3
        end do       !im=im1,12

        if (iopt_BGT.eq.1) then

c-------Change signs for the right face and front face terms to be consistent with the sign convention
          sumrtface= -sumrtface
          sumftface= -sumftface
c-------Write budgets-------------------------------------------------------------------------                        
          do i=1,nzones 
            write(30+i,'(i5,12ES14.6)') ny,sumw(i),sumr(i),sumet(i),
     +          sumsto(i),sumrtface(i),sumftface(i),
     +          SUMFIS(i),SUMFTA(i),SUMFOS(i),SUMOVRNF(I),SUMPRECIP(I),
     +          SUMSTRET(I)
          end do
        endif         !(iopt_BGT.eq.1)
      end do

c        1         2         3         4         5         6         7 2
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------------------------------           
      if (iopt_BGT.eq.1) then
        CLOSE(11)
        CLOSE(12)
        CLOSE(13)
!        CLOSE(14)
        CLOSE(15)
        DO I=1,NZONES
          CLOSE(30+I)
        END DO
      endif         !(iopt_BGT.eq.1)

      CLOSE(16)
      if(nhyd.gt.0) then
        CLOSE(17)        !input:  computed heads
        CLOSE(30)        !output: hydrographs
      endif

      stop
      end
